---
#######################################################################
#                                                                     #
#   Create S3 Buckets                                                 #
#                                                                     #
#######################################################################
- name: "stack | lambda-s3 | debug | params"
  debug: var=s3_params
  when: aws_lambda_params.debug
  tags:
    - aws
    - lambda
    - aws:lambda
    - lambda:s3
    - aws:lambda:s3

- name: "stack | lambda-s3 | set_fact | cftags_lambda_s3"
  set_fact:
    cftags_lambda_s3: "{{ cftags_lambda_s3 | default({}) | combine({item.key:item.value}) | combine(cloudformation_tags | default({})) }}"
  with_dict:
    "{{ tag_prefix }}:owner"           : "{{ owner }}"
    "{{ tag_prefix }}:environment"     : "{{ environment_type }}"
    "{{ tag_prefix }}:environment_abbr": "{{ environment_abbr }}"
    "{{ tag_prefix }}:account"         : "{{ account_name }}"
    "{{ tag_prefix }}:role"            : "lambda"
  tags:
    - aws
    - lambda
    - aws:lambda
    - lambda:s3
    - aws:lambda:s3

- name: "stack | lambda-s3 | cloudformation"
  cloudformation:
    state              : present
    template           : "{{ role_path + '/files/cf-s3.yaml' }}"
    create_changeset   : "{{ aws_lambda_params.create_changeset }}"
    stack_name         : "lambda-s3"
    region             : "{{ aws_region }}"
    tags               : "{{ cftags_lambda_s3 }}"
    template_parameters:
      AccountName: "{{ account_name }}"
  tags:
    - aws
    - lambda
    - aws:lambda
    - lambda:s3
    - aws:lambda:s3

- name: "stack | lambda-s3 | debug | register"
  cloudformation_facts:
    stack_name: "lambda-s3"
    region    : "{{ aws_region }}"
  register: result
  when: aws_lambda_params.debug
  tags:
    - aws
    - lambda
    - aws:lambda
    - lambda:s3
    - aws:lambda:s3

- name: "stack | lambda-s3 | debug | print"
  debug: var=result.ansible_facts.cloudformation['lambda-s3']
  when: aws_lambda_params.debug
  tags:
    - aws
    - lambda
    - aws:lambda
    - lambda:s3
    - aws:lambda:s3
